variable "soa_records" {
  default = {}
  type = map(object({
    zone    = string
    ttl     = number
    records = set(string)
  }))
}
variable "ns_records" {
  default = {}
  type = map(object({
    zone    = string
    ttl     = number
    records = set(string)
  }))
}
variable "mx_records" {
  default = {}
  type = map(object({
    zone    = string
    ttl     = number
    records = set(string)
  }))

}
variable "txt_records" {
  default = {}
  type = map(object({
    zone    = string
    ttl     = number
    records = set(string)
  }))
}
variable "a_records" {
  default = {}
  type = map(object({
    zone    = string
    ttl     = number
    records = set(string)
  }))
}
variable "cname_records" {
  default = {}
  type = map(object({
    zone    = string
    ttl     = number
    records = set(string)
  }))
}

# I want to auto these PTR records somehow
variable "ptr_records" {
  default = {}
}

variable "alias_a_records" {
  default = {}
  type = map(object({
    zone = string
    alias = object({
      name                   = string
      zone_id                = string
      evaluate_target_health = bool
    })
  }))
}

resource "powerdns_record" "a_record" {
  for_each = var.a_records
  name     = each.key
  zone     = each.value["zone"]
  type     = "A"
  ttl      = each.value["ttl"]
  records  = each.value["records"]
}
resource "powerdns_record" "cname_record" {
  for_each = var.cname_records
  name     = each.key
  zone     = each.value["zone"]
  type     = "CNAME"
  ttl      = each.value["ttl"]
  records  = each.value["records"]
}
resource "powerdns_record" "mx_record" {
  for_each = var.mx_records
  name     = each.key
  zone     = each.value["zone"]
  type     = "MX"
  ttl      = each.value["ttl"]
  records  = each.value["records"]
}
resource "powerdns_record" "ns_record" {
  for_each = var.ns_records
  name     = each.key
  zone     = each.value["zone"]
  type     = "NS"
  ttl      = each.value["ttl"]
  records  = each.value["records"]
}
resource "powerdns_record" "ptr_record" {
  for_each = var.ptr_records
  name     = each.key
  zone     = each.value["zone"]
  type     = "PTR"
  ttl      = each.value["ttl"]
  records  = each.value["records"]
}
resource "powerdns_record" "soa_record" {
  for_each = var.soa_records
  name     = each.key
  zone     = each.value["zone"]
  type     = "SOA"
  ttl      = each.value["ttl"]
  records  = each.value["records"]
}
resource "powerdns_record" "txt_record" {
  for_each = var.txt_records
  name     = each.key
  zone     = each.value["zone"]
  type     = "TXT"
  ttl      = each.value["ttl"]
  records  = each.value["records"]
}
